Page MenuHomePhabricator

Theme: People and Processes
Closed, ResolvedPublic

Description

Theme program committee

@BmuellerBirgit MüllerWMF Director of Technical Engagement
@gregGreg GrossmeierWMF Release Engineering Team Manager. Program Committee Chair

Theme proposal

Clear processes, good team practices and an open and friendly environment are key for our platform, community and teams. In this track we will explore aspects of working together in Free and Open Source projects & talk about Platform Stewardship, code review, collaboration, team practices and more. We will work on concrete action items and gather recommendations for current and potential future programs & initiatives.

Session proposals

See sub-tasks

Event Timeline

Rfarrand created this task.Sep 27 2019, 6:29 PM
Rfarrand updated the task description. (Show Details)
Rfarrand triaged this task as Medium priority.Sep 27 2019, 6:32 PM
Rfarrand reassigned this task from Rfarrand to Bmueller.Sep 27 2019, 6:39 PM
Rfarrand updated the task description. (Show Details)Oct 4 2019, 12:22 AM

The session proposals will be added to this task tomorrow and an email will go out to techconf attendees asking for feedback on theme and session proposals before they are finalized.

Rfarrand updated the task description. (Show Details)Oct 4 2019, 6:50 PM
hashar updated the task description. (Show Details)Oct 7 2019, 1:16 PM
Bmueller updated the task description. (Show Details)Oct 8 2019, 5:58 PM
TheDJ added a subscriber: TheDJ.Oct 12 2019, 2:52 PM

Something that I'm missing here honestly, is the dedication to educate and teach new developers/team members as a core principle, before tossing them into the deep end... This is honestly more of an internal WMF thing to decide on, but work in that area can easily benefit any contributor and I think WMF is rather bad at this area (possibly because of their history of people who 'grew up with the codebase'..

Anyway.. Google's, Facebook and Gitlab's onboarding processes for developers sort of pale in comparison with WMFs and this reflects and influences the ability of outside contributors as well. I'd love to have some attention to that...

Hey @TheDJ, there is: T234087 - but it probably only covers parts of that? Do you have a concrete proposal in mind?

P.S. Just remembered that there is also T234633, that's probably more related.

Tgr added a subscriber: Tgr.Oct 13 2019, 9:37 PM

How to share the burden of technical debt (e.g. how to make the implementation of accepted RfCs like dependency injection or extension registration not take the better part of a decade) would also be a useful topic. (Maybe that falls under platform stewardship?)

TK-999 added a subscriber: TK-999.Oct 16 2019, 9:34 PM

How to share the burden of technical debt (e.g. how to make the implementation of accepted RfCs like dependency injection or extension registration not take the better part of a decade) would also be a useful topic. (Maybe that falls under platform stewardship?)

It could be interesting to look at this in the context of T234662. As someone who sometimes contributes to MediaWiki in a volunteer capacity, I am sometimes unsure how to best help with such work. Using DI as an example, should one just "be bold" and write code to replace something that could be servicized, then submit it for review, or would it be a better use of team resources to reach out prior to starting the work and discuss a design first? (If yes, who would handle that? etc.)

CKoerner_WMF added a subscriber: CKoerner_WMF.EditedNov 15 2019, 2:06 PM

Something that I'm missing here honestly, is the dedication to educate and teach new developers/team members as a core principle, before tossing them into the deep end... This is honestly more of an internal WMF thing to decide on, but work in that area can easily benefit any contributor and I think WMF is rather bad at this area (possibly because of their history of people who 'grew up with the codebase'..

@TheDJ Staff orientation around understanding the community, their values and norms, is planned to be part of the Senior Communications Strategist position we're (Community Relations) currently hiring for. There has been some internal (to the WMF) progress, but will officially be within the remit of this role once filled. I've helped draft some framework around this and would be happy to chat about it.

debt added a comment.EditedNov 15 2019, 9:47 PM

Notes from recap and regroup ending session (done world cafe style)


Wikimedia Technical Conference
Atlanta, GA USA
November 12 - 15, 2019

Session Name / Topic
People and Processes regroup and reflection
Session Leader: Birgit; Scribe: Deb
https://phabricator.wikimedia.org/T238406

Overview:

**platform stewardship - https://phabricator.wikimedia.org/T234657**

  • missing a process for sunsetting, how to remove things from production, best practices

**best practices for remote teams - https://phabricator.wikimedia.org/T234658**

  • more equity with timezones and sharing of best processes across teams

**code review - https://phabricator.wikimedia.org/T234660**

  • key challenges, managing workload, how to measure success, workflows, new ideas

**integrating contributions - https://phabricator.wikimedia.org/T234662**

  • guidance for contributors, small changes for teams like triaging patches with smaller teams, increase discoverability with visual guides for actions that are still needing to be done (this can be in gerrit)

**dev productivity onwiki tooling - https://phabricator.wikimedia.org/T234661**

  • looked at scripts, gadgets, templates and modules. what hinders your productivity as a developer, how does this affect your daily work? found 6 main ideas for improving. publishing gadgets, improving ownership, global templates as a product, create packages of templates and modules, create tracking of how the templates are being used (where)

Questions for groups:

  • What are your main takeaways from the sessions in this theme?
  • What topics, action items, etc. have we missed in this theme?

Notes by group:


Magnolia group:
What are your main takeaways from the sessions in this theme?

  • went to best practices session - really liked that and the approach people took. similar to unconference session that Grant did - how to estimate your work.
  • code review and onwiki tooling - good discussions, good action items.
  • acknowledging that I'm a remote person on a remote team
    • having to explicitly reaching out to other teams, events like this is good for doing that
  • integrating and helping first time contributors
  • platform stewardship - felt like there were a lot of action items, we need to actually followup on them
  • sessions were good and relevant (esp about remote workers). lots of sharing on what worked for them when they're working. onwiki tooling was a good learning experience

What topics, action items, etc. have we missed in this theme?

  • need more about best practices, need more info on best things to do, especially for remote workers
    • would be good to talk about at all hands
  • what's next? :)
  • having more hangouts across remote teams
  • do something like what github does - adds in a 'hey you're new here' message with info
  • our subgroup in a session wasn't able to finish all the questions, but another group did and we mingled answers
  • hard to tell from MW page as far as what comes next / context

Oak
What are your main takeaways from the sessions in this theme?

  • liked the discussion around templates, gadgets and the globalness of them, it's an unappreciated part of MW. we need to discuss this more with Product and Tech cross functional teams
  • heard about limiting what gadgets and scripts do so we know what they're actually doing? But they also help to give new insights into new things (stable vs new and inventive)
  • surprised to hear that there are 10K gadgets out there, could we use this to surface more info?
  • a subscribe me button? for when a gadget is updated, etc?
  • how much is overlapping from one gadget to another. Can we figure out a way to share this information with devs to not recreate the wheel.
  • remote participation discussion was good.

What topics, action items, etc. have we missed in this theme?

  • miss on how we make remote workers work - looking at it from a community member insight. it seems like it's getting worse in the last 3 years. processes, procedures, responsibilities, time zones, release cycles, evaluations, etc...!
    • seems to be hidden in various boards
  • half my time in writing code is to figure out how to deal with the foundation and who in the foundation
    • as a person in the foundation, I have the same issue - challenging to find who is responsible for pieces of software
  • hard to find the right context of things, processes are different and lack of ownership of code

Azalea
What are your main takeaways from the sessions in this theme?

  • enjoyed the talk about code review, not sure we changed anything, but it's good to talk about, need more action items on this but it's hard because it's so diffused

Q: what happens to these conclusion? are we getting new guidance later?
A: it has an owner (Eng Productivity team) and partly in TechEngagement / DevAdvocacy and other teams - this will help to inform future annual planning, similar to last year's event with Platform Evolution. we need more info and we should continue to talk about this. will synthesize these ideas and go forward with possible new working groups, some info will just go 'away' and not talk about it (joke)
Q: some of the subjects should have follow-up on the topics discussed.
A; tickets will eventually be closed

What topics, action items, etc. have we missed in this theme?

  • cloud services - toolforge, VPS
  • code reviews - needed more concrete action items

ACTION: what is the best way to follow up (maybe not using the ticket in Phab to followup)


Basswood
What are your main takeaways from the sessions in this theme?

  • discussed code review - it's hard to improve it, shows that we're not necessarily in the place we need to be. some folks do it all the time, other folks not at all. need to keep quality software around, more folks doing code reviews
    • do we have metrics on this?
      • still the lowest in satisfaction numbers
      • we have them in biturgia, lots of numbers for code reviews but maybe not trends
      • might be too many numbers to look at :)
  • seems like there are a lot of pockets of people that do code reviews at this session....but not everyone. lots of individual efforts in code reviews
  • core platform team seems to be doing better, lots more managing of the code review work is happening and paying attention to code reviews. maybe we can learn from their processes
    • not everyone has time (OKRs, life in general, etc)
  • why isn't this part of the team goals? It should be
  • even if it's not part of your goals, it's still important
  • as we go into Annual Planning, we should make this important and part of the annual plan
  • interesting on how opaque gerrit is - finding someone to review your code or who works on certain repos.
    • this should be fixable
  • unclear on when pushing the submit button in gerrit - if that means I'm really committing something...is it merging or just saving my changes?
    • ACTION: Gerrit is confusing - can we fix it?**

What topics, action items, etc. have we missed in this theme?

  • Gerrit - how we can better understand and make it better

Hickory
What are your main takeaways from the sessions in this theme?

  • I liked the idea of tracking the direct usage of a template, not recursively like we do now. where do I go to see where wikitext is using this, where is it that I might break things with updates to tools
  • global templates session - want to highlight having more global modules. not all modules touch all the 'worms' that templates do - maybe this is an easy place to solve problems with.

Q: why is that less complicated?
A: less need for localization and there aren't as many of them

  • if we could measure work that needs doing, it would help us focus on things.
  • gathering metrics on code reviews and what was your experience with the code review (smiley faces for feedback) :)
    • bathroom cleanliness buttons :)
    • having a plus 2 smiley face

What topics, action items, etc. have we missed in this theme?

  • its easy to get massive imposter syndrome - impacts your productivity. would be worthwhile to explore more. unfamiliar with custom stuff, working with many talented people, the scale of everything.
    • despite all that, we have many silos that are problematic, maybe we can have good silos that are more helpful. to be more focused on the code slice I am working on.
    • it is a kind of a side effect of our growth - we need to be more intentional
    • from a human perspective, we tend to forget the human element when we're trying to be smart. we think that everyone is super confident and smart. we all look things up! we're not super humans! :)
    • be more open to people that are new ...understand that it can be confusing.
    • this happens with all new hires in SRE but it's good to have this discussion :)